#include "lighthouseblue_rc_style.h"
#include "lighthouseblue_style.h"

static void   lighthouseblue_rc_style_init         (LighthouseBlueRcStyle       *style);
static void   lighthouseblue_rc_style_class_init   (LighthouseBlueRcStyleClass  *klass);
static void   lighthouseblue_rc_style_finalize     (GObject                     *object);
static guint  lighthouseblue_rc_style_parse        (GtkRcStyle                  *rc_style,
						    GtkSettings                 *settings,
						    GScanner                    *scanner);
static void   lighthouseblue_rc_style_merge        (GtkRcStyle                  *dest,
						    GtkRcStyle                  *src);


static GtkStyle *lighthouseblue_rc_style_create_style (GtkRcStyle *rc_style);

static GtkRcStyleClass *parent_class;

GType lighthouseblue_type_rc_style = 0;

void
lighthouseblue_rc_style_register_type (GTypeModule *module)
{
  static const GTypeInfo object_info =
  {
    sizeof (LighthouseBlueRcStyleClass),
    (GBaseInitFunc) NULL,
    (GBaseFinalizeFunc) NULL,
    (GClassInitFunc) lighthouseblue_rc_style_class_init,
    NULL,           /* class_finalize */
    NULL,           /* class_data */
    sizeof (LighthouseBlueRcStyle),
    0,              /* n_preallocs */
    (GInstanceInitFunc) lighthouseblue_rc_style_init,
  };
  
  lighthouseblue_type_rc_style = g_type_module_register_type (module,
							      GTK_TYPE_RC_STYLE,
							      "LighthouseBlueRcStyle",
							      &object_info, 0);
}

static void
lighthouseblue_rc_style_init (LighthouseBlueRcStyle *style)
{
}

static void
lighthouseblue_rc_style_class_init (LighthouseBlueRcStyleClass *klass)
{
  GtkRcStyleClass *rc_style_class = GTK_RC_STYLE_CLASS (klass);
  GObjectClass *object_class = G_OBJECT_CLASS (klass);

  parent_class = g_type_class_peek_parent (klass);

  rc_style_class->parse = lighthouseblue_rc_style_parse;
  rc_style_class->merge = lighthouseblue_rc_style_merge;
  rc_style_class->create_style = lighthouseblue_rc_style_create_style;
}

static guint
lighthouseblue_rc_style_parse (GtkRcStyle *rc_style,
			       GtkSettings  *settings,
			       GScanner   *scanner)
{
  g_scanner_get_next_token(scanner);
  return G_TOKEN_NONE;
}

static void
lighthouseblue_rc_style_merge (GtkRcStyle * dest,
			       GtkRcStyle * src)
{
  if (LIGHTHOUSEBLUE_IS_RC_STYLE (src)) {
    LighthouseBlueRcStyle *src_data = LIGHTHOUSEBLUE_RC_STYLE (src);
    LighthouseBlueRcStyle *dest_data = LIGHTHOUSEBLUE_RC_STYLE (dest);

    /*
      g_print("theme_merge_rc_style(\"%s\", \"%s\")\n", dest->name, src->name);
    */
  }
  
  parent_class->merge (dest, src);
}

/* Create an empty style suitable to this RC style
 */
static GtkStyle *
lighthouseblue_rc_style_create_style (GtkRcStyle *rc_style)
{
  void *ptr;
  ptr = GTK_STYLE (g_object_new (LIGHTHOUSEBLUE_TYPE_STYLE, NULL));
  return (GtkStyle *)ptr;
}
